(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
	typeof define === 'function' && define.amd ? define(['react'], factory) :
	(global = global || self, global.ReactAwesomePopover = factory(global.React));
}(this, function (React) { 'use strict';

	React = React && React.hasOwnProperty('default') ? React['default'] : React;

	function _defineProperty(obj, key, value) {
	    if (key in obj) {
	        Object.defineProperty(obj, key, {
	            value: value,
	            enumerable: true,
	            configurable: true,
	            writable: true
	        });
	    } else {
	        obj[key] = value;
	    }
	    return obj;
	}
	function _extends() {
	    _extends = Object.assign || function(target) {
	        for(var i = 1; i < arguments.length; i++){
	            var source = arguments[i];
	            for(var key in source){
	                if (Object.prototype.hasOwnProperty.call(source, key)) {
	                    target[key] = source[key];
	                }
	            }
	        }
	        return target;
	    };
	    return _extends.apply(this, arguments);
	}
	function _objectSpread(target) {
	    for(var i = 1; i < arguments.length; i++){
	        var source = arguments[i] != null ? arguments[i] : {
	        };
	        var ownKeys = Object.keys(source);
	        if (typeof Object.getOwnPropertySymbols === 'function') {
	            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
	                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
	            }));
	        }
	        ownKeys.forEach(function(key) {
	            _defineProperty(target, key, source[key]);
	        });
	    }
	    return target;
	}
	function _throw(e) {
	    throw e;
	}
	var Target = function(param) {
	    var ref1 = param ? param : _throw(new TypeError("Cannot destructure 'undefined' or 'null'")), open = ref1.open, zIndex = ref1.zIndex, children = ref1.children, action = ref1.action, targetRef = ref1.targetRef, setOpen = ref1.setOpen, preventDefault = ref1.preventDefault, stopPropagation = ref1.stopPropagation;
	    var onClick = function(e) {
	        if (preventDefault) e.preventDefault();
	        if (stopPropagation) e.stopPropagation();
	        setOpen();
	    };
	    var onMouseOut = function(param1) {
	        var ref1 = param1 ? param1 : _throw(new TypeError("Cannot destructure 'undefined' or 'null'")), relatedTarget = ref1.relatedTarget;
	        if (relatedTarget.id === 'overlay') {
	            setOpen();
	        }
	    };
	    var defaultStyle = {
	        display: 'inline-block',
	        position: 'relative'
	    };
	    var zIndexStyle = open ? {
	        zIndex: zIndex + 10
	    } : {
	    };
	    var actions = action === 'click' ? {
	        onClick: onClick,
	        onTouchEnd: onClick
	    } : action === 'hover' ? {
	        onMouseOver: setOpen,
	        onMouseOut: onMouseOut
	    } : {
	    };
	    return React.createElement('div', _extends({
	        style: _objectSpread({
	        }, defaultStyle, zIndexStyle),
	        ref: targetRef
	    }, actions), children);
	};

	var DEFAULT_ZINDEX = 1000;

	function _assertThisInitialized(self) {
	    if (self === void 0) {
	        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	    }
	    return self;
	}
	function _classCallCheck(instance, Constructor) {
	    if (!(instance instanceof Constructor)) {
	        throw new TypeError('Cannot call a class as a function');
	    }
	}
	function _defineProperties(target, props) {
	    for(var i = 0; i < props.length; i++){
	        var descriptor = props[i];
	        descriptor.enumerable = descriptor.enumerable || false;
	        descriptor.configurable = true;
	        if ('value' in descriptor) descriptor.writable = true;
	        Object.defineProperty(target, descriptor.key, descriptor);
	    }
	}
	function _createClass(Constructor, protoProps, staticProps) {
	    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
	    if (staticProps) _defineProperties(Constructor, staticProps);
	    return Constructor;
	}
	function _defineProperty$1(obj, key, value) {
	    if (key in obj) {
	        Object.defineProperty(obj, key, {
	            value: value,
	            enumerable: true,
	            configurable: true,
	            writable: true
	        });
	    } else {
	        obj[key] = value;
	    }
	    return obj;
	}
	function _extends$1() {
	    _extends$1 = Object.assign || function(target) {
	        for(var i = 1; i < arguments.length; i++){
	            var source = arguments[i];
	            for(var key in source){
	                if (Object.prototype.hasOwnProperty.call(source, key)) {
	                    target[key] = source[key];
	                }
	            }
	        }
	        return target;
	    };
	    return _extends$1.apply(this, arguments);
	}
	function _getPrototypeOf(o) {
	    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
	        return o.__proto__ || Object.getPrototypeOf(o);
	    };
	    return _getPrototypeOf(o);
	}
	function _inherits(subClass, superClass) {
	    if (typeof superClass !== 'function' && superClass !== null) {
	        throw new TypeError('Super expression must either be null or a function');
	    }
	    subClass.prototype = Object.create(superClass && superClass.prototype, {
	        constructor: {
	            value: subClass,
	            writable: true,
	            configurable: true
	        }
	    });
	    if (superClass) _setPrototypeOf(subClass, superClass);
	}
	function _objectSpread$1(target) {
	    for(var i = 1; i < arguments.length; i++){
	        var source = arguments[i] != null ? arguments[i] : {
	        };
	        var ownKeys = Object.keys(source);
	        if (typeof Object.getOwnPropertySymbols === 'function') {
	            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
	                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
	            }));
	        }
	        ownKeys.forEach(function(key) {
	            _defineProperty$1(target, key, source[key]);
	        });
	    }
	    return target;
	}
	function _objectWithoutProperties(source, excluded) {
	    if (source == null) return {
	    };
	    var target = _objectWithoutPropertiesLoose(source, excluded);
	    var key, i;
	    if (Object.getOwnPropertySymbols) {
	        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
	        for(i = 0; i < sourceSymbolKeys.length; i++){
	            key = sourceSymbolKeys[i];
	            if (excluded.indexOf(key) >= 0) continue;
	            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
	            target[key] = source[key];
	        }
	    }
	    return target;
	}
	function _objectWithoutPropertiesLoose(source, excluded) {
	    if (source == null) return {
	    };
	    var target = {
	    };
	    var sourceKeys = Object.keys(source);
	    var key, i;
	    for(i = 0; i < sourceKeys.length; i++){
	        key = sourceKeys[i];
	        if (excluded.indexOf(key) >= 0) continue;
	        target[key] = source[key];
	    }
	    return target;
	}
	function _possibleConstructorReturn(self, call) {
	    if (call && (_typeof(call) === 'object' || typeof call === 'function')) {
	        return call;
	    }
	    return _assertThisInitialized(self);
	}
	function _setPrototypeOf(o, p) {
	    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
	        o.__proto__ = p;
	        return o;
	    };
	    return _setPrototypeOf(o, p);
	}
	function _throw$1(e) {
	    throw e;
	}
	var _typeof = function(obj) {
	    return obj && obj.constructor === Symbol ? 'symbol' : typeof obj;
	};
	var _Math;
	var Content = function(_Component) {
	    _inherits(Content, _Component);
	    function Content() {
	        var _this;
	        _classCallCheck(this, Content);
	        _this = _possibleConstructorReturn(this, _getPrototypeOf(Content).apply(this, arguments));
	        _defineProperty$1(_assertThisInitialized(_this), 'state', {
	            position: null
	        });
	        _defineProperty$1(_assertThisInitialized(_this), 'contentRef', React.createRef());
	        _defineProperty$1(_assertThisInitialized(_this), 'arrowRef', React.createRef());
	        return _this;
	    }
	    _createClass(Content, [{
	            key: 'componentDidMount',
	            value: function componentDidMount() {
	                var ref = this, ref1 = ref ? ref : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), contentRef = ref1.contentRef, arrowRef = ref1.arrowRef;
	                var ref2 = this.props, ref3 = ref2 ? ref2 : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), targetRef = ref3.targetRef, arrow = ref3.arrow, onOpen = ref3.onOpen, placement = ref3.placement;
	                if (onOpen) onOpen();
	                var targetBound = targetRef.current.getBoundingClientRect();
	                var contentBound = contentRef.current.getBoundingClientRect();
	                var atTop = targetBound.y - contentBound.height;
	                var atRight = window.innerWidth - targetBound.right + contentBound.width;
	                var atLeft = targetBound.x - contentBound.width;
	                var atBottom = window.innerHeight - targetBound.bottom + contentBound.height;
	                var arrowBound = {
	                    width: 0,
	                    height: 0
	                }, arrowClientH = 0;
	                if (arrow) {
	                    arrowBound = arrowRef.current.getBoundingClientRect();
	                    arrowClientH = arrowRef.current.clientHeight;
	                }
	                var pos = [
	                    {
	                        at: 'top-start',
	                        check1: atTop,
	                        check2: window.innerWidth - targetBound.left + contentBound.width,
	                        check3: 0,
	                        style: {
	                            top: -(contentBound.height + arrowClientH / 2),
	                            left: 0
	                        },
	                        arrow: {
	                            transform: 'rotate(135deg)',
	                            bottom: -Math.ceil(arrowClientH / 2),
	                            left: Math.min(targetBound.width / 2, contentBound.width) - arrowBound.width / 2
	                        }
	                    },
	                    {
	                        at: 'top-center',
	                        check1: atTop,
	                        check2: contentBound.x - targetBound.width - contentBound.width / 2 + targetBound.width / 2,
	                        check3: window.innerWidth - contentBound.x - targetBound.width - contentBound.width / 2 + targetBound.width / 2 + contentBound.width,
	                        style: {
	                            top: -(contentBound.height + arrowClientH / 2),
	                            left: -(contentBound.width / 2) + targetBound.width / 2
	                        },
	                        arrow: {
	                            transform: 'rotate(135deg)',
	                            bottom: -Math.ceil(arrowClientH / 2),
	                            left: contentBound.width / 2 - arrowBound.width / 2
	                        }
	                    },
	                    {
	                        at: 'top-end',
	                        check1: atTop,
	                        check2: targetBound.right - contentBound.width,
	                        check3: 0,
	                        style: {
	                            top: -(contentBound.height + arrowBound.height / 2),
	                            left: -(contentBound.width - targetBound.width)
	                        },
	                        arrow: {
	                            transform: 'rotate(135deg)',
	                            bottom: -arrowBound.height / 2,
	                            right: Math.min(targetBound.width / 2, contentBound.width) - arrowBound.width / 2
	                        }
	                    },
	                    {
	                        at: 'left-start',
	                        check1: atLeft,
	                        check2: window.innerHeight - targetBound.top + contentBound.height,
	                        check3: 0,
	                        style: {
	                            left: -(contentBound.width + arrowBound.width / 2)
	                        },
	                        arrow: {
	                            top: Math.min(targetBound.height / 2, contentBound.height) - arrowClientH / 2,
	                            left: contentBound.width - arrowBound.width / 2,
	                            transform: 'rotate(45deg)'
	                        }
	                    },
	                    {
	                        at: 'left-center',
	                        check1: atLeft,
	                        check2: contentBound.y - contentBound.height / 2 + targetBound.height / 2,
	                        check3: window.innerHeight - contentBound.y - contentBound.height / 2 + targetBound.height / 2 + contentBound.height,
	                        style: {
	                            left: -(contentBound.width + arrowBound.width / 2),
	                            top: -(contentBound.height / 2 - targetBound.height / 2)
	                        },
	                        arrow: {
	                            transform: 'rotate(45deg)',
	                            left: contentBound.width - arrowBound.width / 2,
	                            top: contentBound.height / 2 - arrowClientH / 2
	                        }
	                    },
	                    {
	                        at: 'left-end',
	                        check1: atLeft,
	                        check2: targetBound.bottom - contentBound.height,
	                        check3: 0,
	                        style: {
	                            left: -(contentBound.width + arrowBound.width / 2),
	                            top: -(contentBound.height - targetBound.height)
	                        },
	                        arrow: {
	                            transform: 'rotate(45deg)',
	                            right: -arrowBound.width / 2,
	                            bottom: Math.min(targetBound.height / 2, contentBound.height) - arrowClientH / 2
	                        }
	                    },
	                    {
	                        at: 'right-start',
	                        check1: atRight,
	                        check2: window.innerHeight - targetBound.top + contentBound.height,
	                        check3: 0,
	                        style: {
	                            left: targetBound.width + arrowBound.width / 2
	                        },
	                        arrow: {
	                            transform: 'rotate(45deg)',
	                            left: -arrowBound.width,
	                            top: Math.min(targetBound.height / 2, contentBound.height) - arrowClientH / 2
	                        }
	                    },
	                    {
	                        at: 'right-center',
	                        check1: atRight,
	                        check2: contentBound.y - contentBound.height / 2 + targetBound.height / 2,
	                        check3: window.innerHeight - contentBound.y - contentBound.height / 2 + targetBound.height / 2 + contentBound.height,
	                        style: {
	                            top: -(contentBound.height / 2 - targetBound.height / 2),
	                            left: targetBound.width + arrowBound.width / 2
	                        },
	                        arrow: {
	                            left: -arrowBound.width,
	                            top: contentBound.height / 2 - arrowClientH / 2,
	                            transform: 'rotate(45deg)'
	                        }
	                    },
	                    {
	                        at: 'right-end',
	                        check1: atRight,
	                        check2: targetBound.bottom - contentBound.height,
	                        check3: 0,
	                        style: {
	                            left: targetBound.width + arrowBound.width / 2,
	                            top: -(contentBound.height - targetBound.height)
	                        },
	                        arrow: {
	                            transform: 'rotate(45deg)',
	                            left: -arrowBound.width,
	                            bottom: Math.min(targetBound.height / 2, contentBound.height) - arrowClientH / 2
	                        }
	                    },
	                    {
	                        at: 'bottom-start',
	                        check1: atBottom,
	                        check2: window.innerWidth - targetBound.left + contentBound.width,
	                        check3: 0,
	                        style: {
	                            top: targetBound.height + arrowBound.height / 2,
	                            left: 0
	                        },
	                        arrow: {
	                            transform: 'rotate(-45deg)',
	                            top: -(arrowBound.height / 2),
	                            left: Math.min(targetBound.width / 2, contentBound.width) - arrowBound.width / 2
	                        }
	                    },
	                    {
	                        at: 'bottom-center',
	                        check1: atBottom,
	                        check2: contentBound.x - targetBound.width - contentBound.width / 2 + targetBound.width / 2,
	                        check3: window.innerWidth - contentBound.x - targetBound.width - contentBound.width / 2 + targetBound.width / 2 + contentBound.width,
	                        style: {
	                            top: targetBound.height + arrowClientH / 2,
	                            left: -(contentBound.width / 2) + targetBound.width / 2
	                        },
	                        arrow: {
	                            transform: 'rotate(-45deg)',
	                            top: -arrowClientH / 2,
	                            left: contentBound.width / 2 - arrowBound.width / 2
	                        }
	                    },
	                    {
	                        at: 'bottom-end',
	                        check1: atBottom,
	                        check2: atLeft,
	                        check3: 0,
	                        style: {
	                            top: targetBound.height + arrowBound.height / 2,
	                            left: -(contentBound.width - targetBound.width)
	                        },
	                        arrow: {
	                            transform: 'rotate(-45deg)',
	                            top: -(arrowBound.height / 2),
	                            right: Math.min(targetBound.width / 2, contentBound.width) - arrowBound.width / 2
	                        }
	                    }, 
	                ];
	                var compute = pos.map(function(val) {
	                    return val.check1 - val.check2 - val.check3;
	                });
	                var getIndex = compute.indexOf((_Math = Math).max.apply(_Math, compute));
	                var result = placement !== 'auto' ? pos.filter(function(val) {
	                    return val.at === placement;
	                })[0] : pos[getIndex];
	                this.setState({
	                    position: result
	                });
	            }
	        }, {
	            key: 'componentWillUnmount',
	            value: function componentWillUnmount() {
	                var ref = this.props, ref1 = ref ? ref : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), onClose = ref1.onClose;
	                if (onClose) onClose();
	            }
	        }, {
	            key: 'render',
	            value: function render() {
	                var ref5 = this.state, ref1 = ref5 ? ref5 : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), position = ref1.position;
	                var defaultStyle = {
	                    display: 'inline-block',
	                    position: 'absolute',
	                    zIndex: DEFAULT_ZINDEX + 10
	                };
	                var positionStyle = position ? position.style : {
	                };
	                var arrowStyle = position ? position.arrow : {
	                };
	                var ref2 = this.props, ref3 = ref2 ? ref2 : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), content = ref3.content, arrow = ref3.arrow, _ref$arrowProps = ref3.arrowProps, arrowProps = _ref$arrowProps === void 0 ? {
	                } : _ref$arrowProps;
	                var ref4 = arrowProps ? arrowProps : _throw$1(new TypeError("Cannot destructure 'undefined' or 'null'")), _ref$style = ref4.style, style = _ref$style === void 0 ? {
	                } : _ref$style, arrowRest = _objectWithoutProperties(arrowProps, [
	                    'style'
	                ]);
	                return React.createElement('div', {
	                    style: _objectSpread$1({
	                    }, defaultStyle, positionStyle),
	                    ref: this.contentRef
	                }, arrow ? React.createElement('div', _extends$1({
	                    ref: this.arrowRef,
	                    style: _objectSpread$1({
	                    }, _objectSpread$1({
	                        position: 'absolute'
	                    }, arrowStyle), style)
	                }, arrowRest), '◥') : null, content);
	            }
	        }]);
	    return Content;
	}(React.Component);

	function _extends$2() {
	    _extends$2 = Object.assign || function(target) {
	        for(var i = 1; i < arguments.length; i++){
	            var source = arguments[i];
	            for(var key in source){
	                if (Object.prototype.hasOwnProperty.call(source, key)) {
	                    target[key] = source[key];
	                }
	            }
	        }
	        return target;
	    };
	    return _extends$2.apply(this, arguments);
	}
	function _throw$2(e) {
	    throw e;
	}
	var Overlay = function(param) {
	    var ref = param ? param : _throw$2(new TypeError("Cannot destructure 'undefined' or 'null'")), onClose = ref.onClose, _ref$overlayColor = ref.overlayColor, overlayColor = _ref$overlayColor === void 0 ? 'rgba(0,0,0,0.5)' : _ref$overlayColor, zIndex = ref.zIndex, action = ref.action, setOpen = ref.setOpen;
	    var onClick = function(e) {
	        e.preventDefault();
	        e.stopPropagation();
	        onClose();
	    };
	    var actions = action === 'click' ? {
	        onClick: onClick,
	        onTouchEnd: onClick
	    } : action === 'hover' ? {
	        onMouseEnter: setOpen
	    } : {
	    };
	    return React.createElement('div', _extends$2({
	        style: {
	            backgroundColor: overlayColor,
	            position: 'fixed',
	            width: '100%',
	            height: '100%',
	            top: 0,
	            left: 0,
	            cursor: 'pointer',
	            zIndex: zIndex
	        }
	    }, actions));
	};

	function _assertThisInitialized$1(self) {
	    if (self === void 0) {
	        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
	    }
	    return self;
	}
	function _classCallCheck$1(instance, Constructor) {
	    if (!(instance instanceof Constructor)) {
	        throw new TypeError('Cannot call a class as a function');
	    }
	}
	function _defineProperties$1(target, props) {
	    for(var i = 0; i < props.length; i++){
	        var descriptor = props[i];
	        descriptor.enumerable = descriptor.enumerable || false;
	        descriptor.configurable = true;
	        if ('value' in descriptor) descriptor.writable = true;
	        Object.defineProperty(target, descriptor.key, descriptor);
	    }
	}
	function _createClass$1(Constructor, protoProps, staticProps) {
	    if (protoProps) _defineProperties$1(Constructor.prototype, protoProps);
	    if (staticProps) _defineProperties$1(Constructor, staticProps);
	    return Constructor;
	}
	function _defineProperty$2(obj, key, value) {
	    if (key in obj) {
	        Object.defineProperty(obj, key, {
	            value: value,
	            enumerable: true,
	            configurable: true,
	            writable: true
	        });
	    } else {
	        obj[key] = value;
	    }
	    return obj;
	}
	function _extends$3() {
	    _extends$3 = Object.assign || function(target) {
	        for(var i = 1; i < arguments.length; i++){
	            var source = arguments[i];
	            for(var key in source){
	                if (Object.prototype.hasOwnProperty.call(source, key)) {
	                    target[key] = source[key];
	                }
	            }
	        }
	        return target;
	    };
	    return _extends$3.apply(this, arguments);
	}
	function _getPrototypeOf$1(o) {
	    _getPrototypeOf$1 = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
	        return o.__proto__ || Object.getPrototypeOf(o);
	    };
	    return _getPrototypeOf$1(o);
	}
	function _inherits$1(subClass, superClass) {
	    if (typeof superClass !== 'function' && superClass !== null) {
	        throw new TypeError('Super expression must either be null or a function');
	    }
	    subClass.prototype = Object.create(superClass && superClass.prototype, {
	        constructor: {
	            value: subClass,
	            writable: true,
	            configurable: true
	        }
	    });
	    if (superClass) _setPrototypeOf$1(subClass, superClass);
	}
	function _objectSpread$2(target) {
	    for(var i = 1; i < arguments.length; i++){
	        var source = arguments[i] != null ? arguments[i] : {
	        };
	        var ownKeys = Object.keys(source);
	        if (typeof Object.getOwnPropertySymbols === 'function') {
	            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
	                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
	            }));
	        }
	        ownKeys.forEach(function(key) {
	            _defineProperty$2(target, key, source[key]);
	        });
	    }
	    return target;
	}
	function _objectWithoutProperties$1(source, excluded) {
	    if (source == null) return {
	    };
	    var target = _objectWithoutPropertiesLoose$1(source, excluded);
	    var key, i;
	    if (Object.getOwnPropertySymbols) {
	        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
	        for(i = 0; i < sourceSymbolKeys.length; i++){
	            key = sourceSymbolKeys[i];
	            if (excluded.indexOf(key) >= 0) continue;
	            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
	            target[key] = source[key];
	        }
	    }
	    return target;
	}
	function _objectWithoutPropertiesLoose$1(source, excluded) {
	    if (source == null) return {
	    };
	    var target = {
	    };
	    var sourceKeys = Object.keys(source);
	    var key, i;
	    for(i = 0; i < sourceKeys.length; i++){
	        key = sourceKeys[i];
	        if (excluded.indexOf(key) >= 0) continue;
	        target[key] = source[key];
	    }
	    return target;
	}
	function _possibleConstructorReturn$1(self, call) {
	    if (call && (_typeof$1(call) === 'object' || typeof call === 'function')) {
	        return call;
	    }
	    return _assertThisInitialized$1(self);
	}
	function _setPrototypeOf$1(o, p) {
	    _setPrototypeOf$1 = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
	        o.__proto__ = p;
	        return o;
	    };
	    return _setPrototypeOf$1(o, p);
	}
	function _throw$3(e) {
	    throw e;
	}
	var _typeof$1 = function(obj) {
	    return obj && obj.constructor === Symbol ? 'symbol' : typeof obj;
	};
	var Popover = function(_Component) {
	    _inherits$1(Popover, _Component);
	    function Popover() {
	        var _this;
	        _classCallCheck$1(this, Popover);
	        _this = _possibleConstructorReturn$1(this, _getPrototypeOf$1(Popover).apply(this, arguments));
	        _defineProperty$2(_assertThisInitialized$1(_this), 'state', {
	            open: _this.props.open || false
	        });
	        _defineProperty$2(_assertThisInitialized$1(_this), 'target', React.createRef());
	        _defineProperty$2(_assertThisInitialized$1(_this), 'setOpen', function() {
	            _this.setState({
	                open: !_this.state.open
	            });
	        });
	        return _this;
	    }
	    _createClass$1(Popover, [{
	            key: 'componentDidUpdate',
	            value: function componentDidUpdate(prevProps) {
	                if (prevProps.open !== this.props.open) {
	                    this.setState({
	                        open: this.props.open
	                    });
	                }
	            }
	        }, {
	            key: 'render',
	            value: function render() {
	                var ref = this, ref1 = ref ? ref : _throw$3(new TypeError("Cannot destructure 'undefined' or 'null'")), props = ref1.props;
	                var ref2 = props ? props : _throw$3(new TypeError("Cannot destructure 'undefined' or 'null'")), _ref$placement = ref2.placement, placement = _ref$placement === void 0 ? 'auto' : _ref$placement, _ref$arrow = ref2.arrow, arrow = _ref$arrow === void 0 ? true : _ref$arrow, _ref$action = ref2.action, action = _ref$action === void 0 ? 'click' : _ref$action, _ref$zIndex = ref2.zIndex, zIndex = _ref$zIndex === void 0 ? DEFAULT_ZINDEX : _ref$zIndex, preventDefault = ref2.preventDefault, stopPropagation = ref2.stopPropagation, onOpen = ref2.onOpen, onClose = ref2.onClose, children = ref2.children, style = ref2.style, overlayColor = ref2.overlayColor, arrowProps = ref2.arrowProps, rest = _objectWithoutProperties$1(props, [
	                    'placement',
	                    'arrow',
	                    'action',
	                    'zIndex',
	                    'preventDefault',
	                    'stopPropagation',
	                    'onOpen',
	                    'onClose',
	                    'children',
	                    'style',
	                    'overlayColor',
	                    'arrowProps'
	                ]);
	                var target = children[0], content = children[1];
	                return React.createElement('div', _extends$3({
	                    style: _objectSpread$2({
	                    }, {
	                        position: 'relative'
	                    }, style)
	                }, rest), React.createElement(Target, {
	                    preventDefault: preventDefault,
	                    stopPropagation: stopPropagation,
	                    targetRef: this.target,
	                    open: this.state.open,
	                    zIndex: zIndex,
	                    action: action,
	                    setOpen: this.setOpen
	                }, target), this.state.open && React.createElement(Content, {
	                    arrowProps: arrowProps,
	                    zIndex: zIndex,
	                    arrow: arrow,
	                    placement: placement,
	                    targetRef: this.target,
	                    content: content,
	                    onClose: onClose,
	                    onOpen: onOpen
	                }), this.state.open ? React.createElement(Overlay, {
	                    overlayColor: overlayColor,
	                    onClose: this.setOpen,
	                    zIndex: zIndex,
	                    action: action,
	                    setOpen: this.setOpen
	                }) : null);
	            }
	        }]);
	    return Popover;
	}(React.Component);

	return Popover;

}));
